// sig2.cpp
// Glenn G. Chappell
// 15 Feb 2013
//
// For CS 321 Spring 2013
// Alarm demo

#include <iostream>
using std::cout;
using std::endl;
#include <unistd.h>  // for alarm
#include <signal.h>  // for signal, SIGALRM


volatile char c = 'A';  // Char to print; altered by handler


// handler
// Signal handler
// Prints message and bumps up global count
void handler(int i)  // param is which signal 
{
    cout << "********** ALARM!!!  Bumping up char" << endl;
    ++c;

    alarm(5);  // Another alarm 5 secs from now
}


// main
// Install handler for SIGINT, slowly prints increasing numbers
int main()
{
    // Set up signal handler for SIGALRM
    //  (sent by expiration of alarm timer)
    signal(SIGALRM, handler);
    
    // Set the alarm
    alarm(5);  // 5 seconds from now
    cout << "Alarm in 5 seconds" << endl;
    cout << endl;

    while (true)
    {
        // Count up for a while, slowly
        for (int count = 0; count < 1000000000; ++count)
        {
            cout << "c = '" << c
                 << "'    count = " << count << endl;
            for (volatile int k = 0; k < 30000000; ++k) ;
                // "volatile" so no optimizing out our delay loop
        }
    }

    return 0;
}

